#!/usr/local/bin/ruby
# coding: utf-8


require './enigmalib.rb'

#enigma = Enigma.new(PLUGBOARD_WIRE, [ ROTOR1_WIRE, ROTOR2_WIRE, ROTOR3_WIRE],
#                    [ ROTOR1_NOTCH, ROTOR2_NOTCH, ROTOR3_NOTCH ],
#                    [ 0, 0, 0 ],
#                    REFLECTOR1_WIRE)

#p enigma.rotor[0].set_init_pos("A")

#(0..26).each do |i|
#    p i
#    p r.step
#    p ""
#end


rotor = [ nil, ROTOR1_WIRE, ROTOR2_WIRE, ROTOR3_WIRE, ROTOR4_WIRE,
          ROTOR5_WIRE, ROTOR6_WIRE, ROTOR7_WIRE, ROTOR8_WIRE ]
notch = [ nil, ROTOR1_NOTCH, ROTOR2_NOTCH, ROTOR3_NOTCH, ROTOR4_NOTCH,
          ROTOR5_NOTCH, ROTOR6_NOTCH, ROTOR7_NOTCH, ROTOR8_NOTCH ]


#p enigma.convert("aaa")


def print_usage
    print <<EOF
usage: enigma.rb rotor#1 rotor#2 rotor#3 [ startpos_string ]
Plain text or cipher text input should be given as STDIN
平文または暗号文の入力は標準入力からあたえる
./enigma.rb 1 2 3 < hogehoge.txt
EOF
end



if ARGV.length < 3 
    print_usage()
    exit
end

rotor_setting = Array.new
rotor_notch = Array.new
rotor_setting[0] = rotor[ARGV[0].to_i]
rotor_setting[1] = rotor[ARGV[1].to_i]
rotor_setting[2] = rotor[ARGV[2].to_i]
rotor_notch[0] = notch[ARGV[0].to_i]
rotor_notch[1] = notch[ARGV[1].to_i]
rotor_notch[2] = notch[ARGV[2].to_i]

enigma = Enigma.new(PLUGBOARD_WIRE, rotor_setting,
                    rotor_notch, [ 0, 0, 0 ], REFLECTOR1_WIRE)


start_pos = Array.new
if ARGV.length == 4
    if ARGV[3].match(/^[A-Za-z]{3}$/)
        start_pos = ARGV[3].upcase.split(//)
        enigma.rotor[0].set_init_pos(start_pos[0])
        enigma.rotor[1].set_init_pos(start_pos[1])
        enigma.rotor[2].set_init_pos(start_pos[2])
    end
end


#p start_pos 
#p enigma


input_text = ""
STDIN.each do |input_line|
    input_line.chop!
    input_text += input_line + "\n"
end


print enigma.convert(input_text)
